package com.agilefaqs.problem;

import static org.junit.Assert.assertEquals;

import java.io.IOException;

import org.junit.Test;

public class MyLoggerTest implements Console {
    private String msg;
    private MyLogger logger = new MyLogger(this);

    @Test
    public void handleNonIOExceptions() {
        logger.error(new IllegalArgumentException("Ignore Exception"));
        assertEquals("SEVERE: Dying due to exception : Ignore Exception", msg);
    }

    @Test
    public void ignoreSpecificIOExceptions() {
        String errorMsg = "Broken pipe:" + Math.random();
        logger.error(new IOException(errorMsg));
        assertEquals("FINE: Ignoring Exception for : " + errorMsg, msg);
    }

    @Test
    public void handleGenericIOExceptions() {
        String errorMsg = "Random IO Error:" + Math.random();
        logger.error(new IOException(errorMsg));
        assertEquals("SEVERE: Dying due to exception : " + errorMsg, msg);
    }

    @Override
    public void write(final String msg) {
        this.msg = msg;
    }
}
